<!DOCTYPE html>
<html lang="en" th:lang="#{lang}" xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security">
<head>
    <!--CSS -->
    <link th:href="@{/css/lightpick.css}" rel="stylesheet" type="text/css">
    <link th:href="@{/css/jquery.timepicker.min.css}" rel="stylesheet" type="text/css">

    <!--<link  href="https://cdnjs.cloudflare.com/ajax/libs/fotorama/4.6.4/fotorama.css" rel="stylesheet">-->

    <!--/*/ <th:block th:include="fragments/layout :: head">
        </th:block> /*/-->


    <!--<script src="https://cdnjs.cloudflare.com/ajax/libs/fotorama/4.6.4/fotorama.js"></script>-->

    <!--SCRIPTS-->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
    <script th:src="@{/js/lightpick.js}" type="text/javascript"></script>
    <script th:src="@{/js/jquery.timepicker.min.js}" type="text/javascript"></script>
</head>
<body>

<div id="wrapper">

    <div th:replace="fragments/layout :: header('Vrácení výpůjčky', @{/}, '')"></div>

    <main id="main" class="container">


        <div class="flex-grow-1 p-2">

            <!--ALERTS-->
            <div th:replace="fragments/layout :: alerts"></div>

            <div>
                <form id="product-form" class="needs-validation" method="post" enctype="multipart/form-data"
                      autocomplete="off"
                      th:action="@{/admin/borrow/return}" th:object="${borrow}"
                      novalidate>

                    <input type="hidden" th:field="*{id}">
                    <input type="hidden" th:field="*{user.id}">

                    <!--USER-->
                    <div class="mb-3">
                        <div class="d-flex pb-1">
                            <label class="font-weight-bold mb-0 mt-1 mr-2">Zákazník:</label>
                        </div>

                        <!--AUTOCOMPLETE USER-->
                        <div class="autocomplete w-100">
                            <input class="form-control" type="text" disabled
                                   th:value="${borrow.user != null ? borrow.user.getFullName() : ''}">
                        </div>
                    </div>

                    <div id="productPart" th:fragment="productPart(borrow)">
                        <!--DATEPICKER-->
                        <div class="form-group">
                            <label for="fromDateInput" class="font-weight-bold">Datum:</label>

                            <!--BORROW ERROR-->
                            <div id="borrowError" class="alert alert-danger alert-dismissible"
                                 th:classappend="${borrowErrorMessage} == null ? 'd-none' : ''"
                                 role="alert">
                                    <span id="borrowErrorMessage"
                                          th:text="${borrowErrorMessage != null ? borrowErrorMessage : ''}"></span>
                                <button type="button" class="close" onclick="closeAlert('#borrowError');">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>

                            <table>
                                <tr>
                                    <td>Vypůjčeno&nbsp;od:</td>
                                    <td class="font-weight-bold text-danger pl-3"
                                        th:text="${borrow.getFormatFromDate()}"></td>
                                </tr>
                                <tr>
                                    <td>Vypůjčeno&nbsp;do:</td>
                                    <td>
                                        <div class="d-flex flex-nowrap">
                                            <input class="text-hide" id="fromDateInput" name="fromDate" required>
                                            <input type="text" id="toDateInput" name="toDate"
                                                   class="font-weight-bold form-control form-control-sm ml-2"
                                                   required>
                                            <div>
                                                <input type="text" name="toTime" id="toTimeInput"
                                                       class="font-weight-bold form-control form-control-sm ml-1"
                                                       th:value="${T(cz.david.minirental.helpers.CalendarHelper).getCurrentTime()}"
                                                       onchange="recalcTotalPrice(); checkDates()" required>
                                                <span class="invalid-feedback">čas musí být větší než počáteční</span>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                            </table>

                        </div>


                        <!--ACCESSORY-->
                        <!--<div class="form-group">
                            <label class="font-weight-bold">Příslušenství:</label>
                            <div>
                                <div th:if="${not #lists.isEmpty(borrow.borrowProducts)}">
                                    <div class="ml-2"
                                         th:each="bProduct,iStat : ${borrow.borrowProducts}">
                                        <label class="control control--checkbox disabled">
                                            <span th:text="${accessory.name}"></span>
                                            <input type="checkbox" tabindex="3" checked="checked" disabled/>
                                            <div class="control__indicator"></div>
                                        </label>
                                        <input type="hidden"
                                               th:field="${borrow.accessories[__${iStat.index}__].name}">
                                    </div>
                                </div>
                            </div>
                        </div>-->

                        <!--ACCESSORY-->
                        <div id="accessories" class="form-group" th:fragment="accessories(borrow)">
                            <label class="font-weight-bold">Příslušenství:</label>
                            <div th:each="bProduct, iStatBP : ${borrow.borrowProducts}">

                                <div th:if="${not #lists.isEmpty(bProduct.accessories)}">
                                    <label th:text="${bProduct.product.name}"></label>
                                    <div class="ml-2" th:each="accessory,iStatA : ${bProduct.accessories}">
                                        <label class="control control--checkbox cursor-default">
                                            <span th:text="${accessory.name}"></span>
                                            <input type="checkbox" tabindex="3" checked="checked" disabled/>
                                            <div class="control__indicator"></div>
                                        </label>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <!-- PRICE -->
                        <div class="mb-3">
                            <label class="font-weight-bold">Cena:</label>
                            <table class="table w-100">
                                <tbody>
                                <tr th:if="${not #lists.isEmpty(borrow.borrowProducts)}"
                                    th:each="bProduct,iStat : ${borrow.borrowProducts}"
                                    class="table-sm">
                                    <td class="w-100" th:text="${bProduct.product.name}"></td>
                                    <td class="text-nowrap text-left">
                                        <span th:text="${bProduct.getFormatDayPrice()}"></span>
                                        <span> Kč/den</span>
                                    </td>
                                </tr>
                                <tr class="table-sm">
                                    <td>
                                        <span id="dateFrom"></span>
                                        -
                                        <span id="dateTo"></span>
                                    </td>
                                    <td class="text-nowrap text-left">
                                        <span class="dayCount">1</span>
                                        <span id="dayName">den</span>
                                    </td>
                                </tr>
                                <tr class="table-sm table-active">
                                    <td>Celkem</td>
                                    <td class="text-nowrap text-left">
                                        <span id="totalPrice" class="font-weight-bold"></span>
                                        Kč
                                    </td>
                                </tr>
                                </tbody>
                            </table>

                            <!--BONUS/MALUS-->
                            <div class="d-flex flex-nowrap">
                                <label class="control control--checkbox my-1">
                                    Bonus/Malus:
                                    <input type="checkbox" tabindex="-1"
                                           onchange="$('#bonusInput').prop('disabled', !this.checked); recalcTotalPrice()"/>
                                    <div class="control__indicator"></div>
                                </label>
                                <div class="input-group input-group-sm mb-1 ml-3">
                                    <input id="bonusInput" type="number" class="form-control" name="bonus"
                                           th:value="${bonus > 0 ? bonus : '-100'}" disabled
                                           onchange="recalcTotalPrice()">
                                    <div class="input-group-append">
                                        <span class="input-group-text">Kč</span>
                                    </div>
                                </div>
                            </div>
                        </div>


                        <script th:inline="javascript">
                            /*<![CDATA[*/

                            var borrowFromDate = /*[[${borrow.fromDate}]]*/'';
                            var toDateInput = document.getElementById('toDateInput');
                            var toTimeInput = document.getElementById('toTimeInput');
                            var bonusInput = $('#bonusInput');

                            if (!borrowFromDate) {
                                borrowFromDate = moment();
                            } else {
                                borrowFromDate = moment(borrowFromDate);
                            }

                            if (document.getElementById('fromDateInput')) {

                                var isSecondClick = false;

                                var picker = new Lightpick({
                                    field: document.getElementById('fromDateInput'),
                                    secondField: toDateInput,
                                    singleDate: false,
                                    repick: true,
                                    //inline: true,
                                    format: "DD.MM.YYYY",
                                    lang: "cs",
                                    numberOfMonths: ($(window).width() > 750) ? 2 : 1,
                                    minDate: borrowFromDate,
                                    separator: ";",
                                    selectForward: true,
                                    selectBackward: false,
                                    hoveringTooltip: false,
                                    startDate: borrowFromDate,
                                    endDate: borrowFromDate > moment() ? borrowFromDate : moment(),
                                    /*maxDays: 31,*/
                                    onSelect: function (start, end) {
                                        var collisionDates = $('.lightpick__day.is-disabled.is-in-range')
                                        if (collisionDates.length > 0) {
                                            showCollisionDatesError(collisionDates);
                                        } else {
                                            var error = $('#borrowError');
                                            error.removeClass('show');
                                            error.addClass('d-none');
                                        }

                                        checkDates();
                                        recalcTotalPrice();
                                    }
                                });
                            }

                            //TIMEPICKER
                            $('#toTimeInput').timepicker({
                                'timeFormat': 'H:i'
                            });


                            //PRICE
                            var dateFrom = $("#dateFrom");
                            var dateTo = $("#dateTo");
                            var dayName = $("#dayName");
                            var dayCount = $(".dayCount");
                            var totalPriceOutput = $("#totalPrice");
                            var bonusOutput = $("#outputBonus");

                            function recalcTotalPrice() {
                                var toDateTime = toDateInput.value + " " + toTimeInput.value;
                                if (toDateTime) {
                                    var totalPrice = 0;
                                    var toDate = moment(toDateTime, "DD.MM.YYYY HH:mm");
                                    var minutes = toDate.diff(borrowFromDate, 'minutes');

                                    var days = 1;
                                    if (minutes <= 240.0) {
                                        totalPrice = /*[[${borrow.getDiscountPricePerDay()}]]*/ 0;
                                    } else {
                                        minutes -= 120;
                                        days = Math.round((minutes / 1440.0) + 0.5);
                                        if (days < 1)
                                            days = 1;
                                        totalPrice = days * /*[[${borrow.getPricePerDay()}]]*/ 0;
                                    }
                                    dayCount.html(days);
                                    dayName.html(getDayName(days));
                                    if (!bonusInput.prop('disabled')) {
                                        totalPrice += parseFloat(bonusInput.val());
                                        bonusOutput.html(bonusOutput);
                                    } else {
                                        bonusOutput.html();
                                    }
                                    totalPriceOutput.html(formatFloat(totalPrice));
                                    dateFrom.html(borrowFromDate.format('DD.MM HH:mm'));
                                    dateTo.html(toDate.format('DD.MM HH:mm'));
                                }
                            }

                            recalcTotalPrice();

                            /*CHECK DATES*/
                            function checkDates() {
                                var fromDateString = /*[[${borrow.getFormatFromDate()}]]*/'';
                                var toDateString = $('#toDateInput').val();
                                toDateString = toDateString + " " + $('#toTimeInput').val();

                                var fromDate = moment(fromDateString, "DD.MM.YYYY HH:mm");
                                var toDate = moment(toDateString, "DD.MM.YYYY HH:mm");

                                if (toDate < fromDate) {
                                    document.getElementById('toTimeInput').setCustomValidity("invalid");
                                    return false;
                                }
                                document.getElementById('toTimeInput').setCustomValidity("");
                                return true;
                            }

                            /*]]>*/
                        </script>

                    </div>

                    <div class="d-flex flex-wrap">
                        <button id="borrowBtn" type="submit" onclick="checkDates()"
                                th:disabled="${borrow.returnDate != null}"
                                th:text="${borrow.returnDate != null} ? 'Vráceno' : 'Vrátit'"
                                class="w-100 w-sm-auto btn btn-danger ml-auto px-5" tabindex="5">
                            Vrátit
                        </button>
                    </div>

                </form>
            </div>

        </div>

    </main>
</div>

<!--FOOTER-->
<div th:replace="fragments/layout :: footer"></div>

</body>
</html>